import java.awt.*;
import java.applet.*;

/**
 * En generell funktion som verstter en
 * punkt p i omgivningen av storlek r vid tidpunkt time.
 */
interface F
{
    Point f( Point p, Rectangle r, int time );
}

/** En roterande rrelse. */
class Rotating implements F
{
    // Oberoende av P!
    public Point f( Point p, Rectangle r, int time )
    {
	int radius = Math.min( r.width / 2, r.height / 2 );
	double arg = 2 * Math.PI * (time % 100) / 100;
	int x = (int) (r.x + r.width / 2 + radius * Math.cos(arg));
	int y = (int) (r.y + r.height / 2 + radius * Math.sin(arg));

	return new Point( x, y );
    }
}

/** En studsrrelse. */
class Bouncing implements F
{
    // Hastighet
    int dx, dy;

    Bouncing()
    {
	dx = dy = 3;
    }

    // Oberoende av time!
    public Point f( Point p, Rectangle r, int time )
    {
	if (p.x <= 0 || p.x >= r.width)
	    dx = -dx;
	if (p.y <= 0 || p.y >= r.height)
	    dy = -dy;

	return new Point( p.x + dx, p.y + dy );
    }
}

/** Huvudprogram. */
public class Main extends Applet implements Runnable
{
    final int ball_size = 40;

    Point 	p;
    F		f;

    public void init()
    {
	setBackground( Color.blue.darker() );

	p = new Point(200,200);

	// Vlj ngon av dessa nedan.
//	f = new Rotating();
	f = new Bouncing();

	// Fljande kan gras eftersom Applet r en
	// Runnable.
	Thread t = new Thread( this );
	t.start();
    }

    // Innan paint() anropas har ritytan suddats
    // med bakgrundsfrgen.
    public void paint( Graphics g )
    {
	g.setColor( Color.yellow );
	g.fillOval( p.x, p.y, ball_size, ball_size );
    }

    // Denna anropas asynkront till fljd av t.start();
    public void run()
    {
	for (int t = 0;;t++)
	{
	    // Hmta storlek av rityta.
   	    Dimension s = getSize();
  	    Rectangle r = new Rectangle(
			0, 0,
			s.width - ball_size,
			s.height - ball_size );

	    // Berkna punktkoordinat med hjlp av
	    // tidigare punktkoordinat, storlek av
	    // rityta och tidpunkten t.
	    p = f.f( p, r, t );

	    // Se till att paint() anropas (asynkront!)
	    // s vi fr en grafisk uppdatering.
	    repaint();

	    // Vnta i 30 ms.
	    try { Thread.sleep(30); }
	    catch (Exception e) { }
	}
    }
}
