import java.applet.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

class Ball implements Runnable
{
    private Color [] COLORS =
	{ Color.red, Color.orange, Color.yellow,
	  Color.green, Color.cyan, Color.blue,
	  Color.white };
    private int	thisX, thisY;
    private int	thisDX, thisDY;
    private int	thisRadius;
    private Color thisColor;
    private Rectangle thisBoundingBox;

    Ball( int x, int y, Rectangle bounding_box )
    {
	thisX = x;
	thisY = y;
	thisBoundingBox = bounding_box;

	do
	{
	    thisDX = (int)(Math.random() * 10) - 5;
	    thisDY = (int)(Math.random() * 10) - 5;
	} while (thisDX == 0 && thisDY == 0);

	thisRadius = (int)(Math.random() * 10) + 5;
	thisColor = COLORS[(int)(Math.random() * COLORS.length)];

	new Thread( this ).start();
    }

    synchronized public void paint( Graphics g )
    {
	g.setColor( thisColor );
	g.fillOval( thisX - thisRadius, thisY - thisRadius,
		    2*thisRadius, 2*thisRadius );
    }

    public void run()
    {
	for (;;)
        {
	     synchronized (this)
	     {
		thisX += thisDX;
		thisY += thisDY;

		if (!thisBoundingBox.contains(thisX + thisRadius, thisY) ||
		    !thisBoundingBox.contains(thisX - thisRadius, thisY))
		    thisDX = -thisDX;

		if (!thisBoundingBox.contains(thisX, thisY + thisRadius) ||
		    !thisBoundingBox.contains(thisX, thisY - thisRadius))
		    thisDY = -thisDY;
	     }
	     try { Thread.sleep(10); } catch (Exception e) { }
	}
    }
}

public class Main extends Applet implements MouseListener, Runnable
{
    Collection	thisBalls;

    public void init()
    {
	thisBalls = new Vector();
	addMouseListener( this );

	setBackground( Color.black );
    }

    public void start()
    {
	new Thread( this ).start();
    }

    public void run2()
    {
	Image im = new BufferedImage( getSize().width,
				      getSize().height,
				      BufferedImage.TYPE_INT_RGB );
	Graphics im_g = im.getGraphics();

	for (;;)
	{
	    im_g.setColor( getBackground() );
	    im_g.fillRect( 0, 0, getSize().width, getSize().height );
	    paint( im_g );

	    Graphics g = getGraphics();
	    g.drawImage( im, 0, 0, null );
	    g.dispose();

	    try { Thread.sleep(10); } catch (Exception e) { }
	}
    }

    public void run1()
    {
	for (;;)
	{
	    repaint();
	    try { Thread.sleep(10); } catch (Exception e) { }
	}
    }

    public void run()
    {
	run1();
    }

    public void mouseClicked( MouseEvent e )
    {
	synchronized (thisBalls)
	{
	    thisBalls.add(
		new Ball( e.getX(), e.getY(),
		          new Rectangle( 0, 0,
			   	         getSize().width,
					 getSize().height ) ) );
	}
    }

    public void mouseEntered( MouseEvent e )
    {
    }

    public void mouseExited( MouseEvent e )
    {
    }

    public void mousePressed( MouseEvent e )
    {
    }

    public void mouseReleased( MouseEvent e )
    {
    }

    public void paint( Graphics g )
    {
	synchronized (thisBalls)
	{
	    for (Iterator it = thisBalls.iterator();
	         it.hasNext();)
	    {
	        Ball b = (Ball) it.next();
	        b.paint( g );
	    }
	}
    }
}
