import java.awt.*;
import java.applet.*;
import java.awt.event.*;

class BouncingBall
{
    final static int ball_size = 20;

    /** Position */
    int x, y;

    /** Velocity */
    int dx, dy;

    /** Bouncing ball. */
    BouncingBall( int x, int y, int dx, int dy )
    {
	this.x = x;
	this.y = y;
	this.dx = dx;
	this.dy = dy;
    }

    /** Bouncing ball with random velocity. */
    BouncingBall( int x, int y )
    {
	int dx, dy;

	do
	{
	    dx = (int)(Math.random() * 8) - 4;
	    dy = (int)(Math.random() * 8) - 4;
	} while (dx == 0 && dy == 0);

	this.x = x;
	this.y = y;
	this.dx = dx;
	this.dy = dy;
    }

    public void update( Rectangle r, int time )
    {
	if (x <= 0 || x >= r.width)
	    dx = -dx;
	if (y <= 0 || y >= r.height)
	    dy = -dy;

	x = x + dx;
	y = y + dy;
    }

    public void draw( Graphics g )
    {
	g.setColor( Color.yellow );
        g.fillOval( x, y, ball_size, ball_size );
    }
}

class MyMouseListener extends MouseAdapter
{
    Main	main;
    boolean	toggle;

    MyMouseListener( Main m ) { main = m; toggle = false; }

    public void mouseClicked(MouseEvent e)
    {
        main.addBall( e.getX(), e.getY() );
    }
}

/** Huvudprogram. */
public class Main extends Applet implements Runnable
{
    final int max_balls = 100;

    BouncingBall [] 	balls;
    int			n;

    public void addBall( int x, int y )
    {
	balls[n] = new BouncingBall(x,y);
	n++;
    }

    public void init()
    {
	setBackground( Color.blue.darker() );

	addMouseListener( new MyMouseListener( this ) );

	balls = new BouncingBall[max_balls];
	n = 0;

	Thread t = new Thread( this );
	t.start();
    }

    public void paint( Graphics g )
    {
	for (int i = 0; i < n; i++)
	    balls[i].draw( g );
    }

    // Denna anropas asynkront till fljd av t.start();
    public void run()
    {
	for (int t = 0;;t++)
	{
	    // Hmta storlek av rityta.
   	    Dimension s = getSize();
  	    Rectangle r = new Rectangle(
			0, 0,
			s.width - BouncingBall.ball_size,
			s.height - BouncingBall.ball_size );

	    for (int i = 0; i < n; i++)
	        balls[i].update( r, t );

	    repaint();

	    // Vnta i 30 ms.
	    try { Thread.sleep(30); }
	    catch (Exception e) { }
	}
    }
}

